package pm.inf.ethz.ch.pancake

import scala.language.implicitConversions
import Syntax._
import Types._

/** Defines various shorthands and implicit conversions that make it more
  * convenient to create ASTs manually.
  */
object DSL {
  val A = TypeVar("A")
  val B = TypeVar("B")
  val C = TypeVar("C")
  val D = TypeVar("D")

  val x = Var("x")
  val y = Var("y")
  val z = Var("z")
  val f = Var("f")
  val r = Var("r")
  val b = Var("b")
  val id = Var("id")
  val inc = Var("inc")

  implicit def string2Var(s: String): Var = Var(s)
  implicit def bool2BoolLit(b: Boolean): BoolLit = if (b) True else False
  implicit def int2NatLit(n: Int): NatLit = NatLit(n)

  final class TyArrowProvider(val ty1: Type) {
    def →(ty2: Type): Arrow = Arrow(ty1, ty2)
  }

  implicit def type2TyArrowProvider(ty: Type): TyArrowProvider = new TyArrowProvider(ty)
}
