package pm.inf.ethz.ch.pancake

// import Predef.{ArrowAssoc => _, any2ArrowAssoc => _, _}
/* Predef defines an arrow operator as well. It doesn't seem necessary to
 * "unimport" it because it is shadowed by ours imported from DSL, but let's
 * play it safe and keep the corresponding import around.
 */
import org.scalatest.{Matchers, FunSuite}
import Syntax._
import Types._
import DSL._

class AbsTypingTests extends FunSuite with Matchers {
  def inferTypes(term: Term): List[Type] = ???

  ignore("abstraction typing") {
    val t1 = App(Abs(x, Succ(x)), 0)
    val t2 = Abs(f, App(f, 1))
    val t3 = Abs(x, y, Ite(IsZero(x), y, x))
    val t4 = Abs(f, App(f, 1, 0))
    val t5 = Abs(f, b, x, y, Ite(b, App(f, x), App(f, y)))
    val t6 = Abs(f, x, y, App(f, x, y))

    inferTypes(t1) shouldBe List(Nat, Nat)
    inferTypes(t2) shouldBe List(Nat → A, (Nat → A) → A)
    inferTypes(t3) shouldBe List(Nat, Nat, Nat → (Nat → Nat))
    inferTypes(t4) shouldBe List(Nat → (Nat → A), (Nat → (Nat → A)) → A)
    inferTypes(t5) shouldBe List(A → B, Bool, A, A, (A → B) → (Bool → (A → (A → B))))
    inferTypes(t6) shouldBe List(A → (B → C), A, B, (A → (B → C)) → (A → (B → C)))
  }
}
